Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 6613ec959229c059f4df050384fc4621ea87dcc0)
+++ src/tesselation.cpp	(revision 29955407eeb6f84cd775a755f6e7b4d9beba3aa5)
@@ -3688,12 +3688,12 @@
     // calculate smallest distance
     distance = triangle->GetClosestPointInsideTriangle(&Point, &Intersection);
-    Log() << Verbose(1) << "Closest point on triangle is " << Intersection << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Closest point on triangle is " << Intersection << "." << endl);
 
     // then check direction to boundary
     if (DistanceToCenter.ScalarProduct(&triangle->NormalVector) > MYEPSILON) {
-      Log() << Verbose(1) << Point << " is an inner point, " << distance << " below surface." << endl;
+      DoLog(1) && (Log() << Verbose(1) << Point << " is an inner point, " << distance << " below surface." << endl);
       return -distance;
     } else {
-      Log() << Verbose(1) << Point << " is NOT an inner point, " << distance << " above surface." << endl;
+      DoLog(1) && (Log() << Verbose(1) << Point << " is NOT an inner point, " << distance << " above surface." << endl);
       return +distance;
     }
@@ -3775,5 +3775,5 @@
 
     if (takePoint) {
-      Log() << Verbose(1) << "INFO: Endpoint " << *current << " of line " << *(findLines->second) << " is enlisted." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "INFO: Endpoint " << *current << " of line " << *(findLines->second) << " is enlisted." << endl);
       connectedPoints->insert(current);
     }
@@ -3831,5 +3831,5 @@
   }
   PlaneNormal.Scale(1.0 / triangles->size());
-  Log() << Verbose(1) << "INFO: Calculated PlaneNormal of all circle points is " << PlaneNormal << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Calculated PlaneNormal of all circle points is " << PlaneNormal << "." << endl);
   PlaneNormal.Normalize();
 
@@ -3841,5 +3841,5 @@
   }
   if ((Reference == NULL) || (AngleZero.NormSquared() < MYEPSILON)) {
-    Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl);
     AngleZero.CopyVector((*SetOfNeighbours->begin())->node);
     AngleZero.SubtractVector(Point->node);
@@ -3850,10 +3850,10 @@
     }
   }
-  Log() << Verbose(1) << "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << "." << endl);
   if (AngleZero.NormSquared() > MYEPSILON)
     OrthogonalVector.MakeNormalVector(&PlaneNormal, &AngleZero);
   else
     OrthogonalVector.MakeNormalVector(&PlaneNormal);
-  Log() << Verbose(1) << "INFO: OrthogonalVector on plane is " << OrthogonalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: OrthogonalVector on plane is " << OrthogonalVector << "." << endl);
 
   // go through all connected points and calculate angle
@@ -3863,5 +3863,5 @@
     helper.ProjectOntoPlane(&PlaneNormal);
     double angle = GetAngle(helper, AngleZero, OrthogonalVector);
-    Log() << Verbose(0) << "INFO: Calculated angle is " << angle << " for point " << **listRunner << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "INFO: Calculated angle is " << angle << " for point " << **listRunner << "." << endl);
     anglesOfPoints.insert(pair<double, TesselPoint*> (angle, (*listRunner)));
   }
@@ -3909,5 +3909,5 @@
   }
 
-  Log() << Verbose(1) << "INFO: Point is " << *Point << " and Reference is " << *Reference << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Point is " << *Point << " and Reference is " << *Reference << "." << endl);
   // calculate central point
   TesselPointSet::const_iterator TesselA = SetOfNeighbours->begin();
@@ -3920,5 +3920,5 @@
   while (TesselC != SetOfNeighbours->end()) {
     helper.MakeNormalVector((*TesselA)->node, (*TesselB)->node, (*TesselC)->node);
-    Log() << Verbose(0) << "Making normal vector out of " << *(*TesselA) << ", " << *(*TesselB) << " and " << *(*TesselC) << ":" << helper << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Making normal vector out of " << *(*TesselA) << ", " << *(*TesselB) << " and " << *(*TesselC) << ":" << helper << endl);
     counter++;
     TesselA++;
@@ -3936,5 +3936,5 @@
   //  PlaneNormal.SubtractVector(&center);
   //  PlaneNormal.Normalize();
-  Log() << Verbose(1) << "INFO: Calculated plane normal of circle is " << PlaneNormal << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Calculated plane normal of circle is " << PlaneNormal << "." << endl);
 
   // construct one orthogonal vector
@@ -3945,5 +3945,5 @@
   }
   if ((Reference == NULL) || (AngleZero.NormSquared() < MYEPSILON)) {
-    Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl);
     AngleZero.CopyVector((*SetOfNeighbours->begin())->node);
     AngleZero.SubtractVector(Point->node);
@@ -3954,10 +3954,10 @@
     }
   }
-  Log() << Verbose(1) << "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << "." << endl);
   if (AngleZero.NormSquared() > MYEPSILON)
     OrthogonalVector.MakeNormalVector(&PlaneNormal, &AngleZero);
   else
     OrthogonalVector.MakeNormalVector(&PlaneNormal);
-  Log() << Verbose(1) << "INFO: OrthogonalVector on plane is " << OrthogonalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: OrthogonalVector on plane is " << OrthogonalVector << "." << endl);
 
   // go through all connected points and calculate angle
@@ -3970,5 +3970,5 @@
     if (angle > M_PI) // the correction is of no use here (and not desired)
       angle = 2. * M_PI - angle;
-    Log() << Verbose(0) << "INFO: Calculated angle between " << helper << " and " << AngleZero << " is " << angle << " for point " << **listRunner << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "INFO: Calculated angle between " << helper << " and " << AngleZero << " is " << angle << " for point " << **listRunner << "." << endl);
     InserterTest = anglesOfPoints.insert(pair<double, TesselPoint*> (angle, (*listRunner)));
     if (!InserterTest.second) {
@@ -4037,13 +4037,13 @@
         StartLine = CurrentLine;
         CurrentPoint = CurrentLine->GetOtherEndpoint(ReferencePoint);
-        Log() << Verbose(1) << "INFO: Beginning path retrieval at " << *CurrentPoint << " of line " << *CurrentLine << "." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Beginning path retrieval at " << *CurrentPoint << " of line " << *CurrentLine << "." << endl);
         do {
           // push current one
-          Log() << Verbose(1) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl;
+          DoLog(1) && (Log() << Verbose(1) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl);
           connectedPath->push_back(CurrentPoint->node);
 
           // find next triangle
           for (TriangleMap::iterator Runner = CurrentLine->triangles.begin(); Runner != CurrentLine->triangles.end(); Runner++) {
-            Log() << Verbose(1) << "INFO: Inspecting triangle " << *Runner->second << "." << endl;
+            DoLog(1) && (Log() << Verbose(1) << "INFO: Inspecting triangle " << *Runner->second << "." << endl);
             if ((Runner->second != triangle)) { // look for first triangle not equal to old one
               triangle = Runner->second;
@@ -4052,8 +4052,8 @@
                 if (!TriangleRunner->second) {
                   TriangleRunner->second = true;
-                  Log() << Verbose(1) << "INFO: Connecting triangle is " << *triangle << "." << endl;
+                  DoLog(1) && (Log() << Verbose(1) << "INFO: Connecting triangle is " << *triangle << "." << endl);
                   break;
                 } else {
-                  Log() << Verbose(1) << "INFO: Skipping " << *triangle << ", as we have already visited it." << endl;
+                  DoLog(1) && (Log() << Verbose(1) << "INFO: Skipping " << *triangle << ", as we have already visited it." << endl);
                   triangle = NULL;
                 }
@@ -4070,5 +4070,5 @@
             if ((triangle->lines[i] != CurrentLine) && (triangle->lines[i]->ContainsBoundaryPoint(ReferencePoint))) { // not the current line and still containing Point
               CurrentLine = triangle->lines[i];
-              Log() << Verbose(1) << "INFO: Connecting line is " << *CurrentLine << "." << endl;
+              DoLog(1) && (Log() << Verbose(1) << "INFO: Connecting line is " << *CurrentLine << "." << endl);
               break;
             }
@@ -4084,5 +4084,5 @@
         } while (CurrentLine != StartLine);
         // last point is missing, as it's on start line
-        Log() << Verbose(1) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl);
         if (StartLine->GetOtherEndpoint(ReferencePoint)->node != connectedPath->back())
           connectedPath->push_back(StartLine->GetOtherEndpoint(ReferencePoint)->node);
@@ -4090,5 +4090,5 @@
         ListOfPaths->push_back(connectedPath);
       } else {
-        Log() << Verbose(1) << "INFO: Skipping " << *runner->second << ", as we have already visited it." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Skipping " << *runner->second << ", as we have already visited it." << endl);
       }
     }
@@ -4120,5 +4120,5 @@
     connectedPath = *ListRunner;
 
-    Log() << Verbose(1) << "INFO: Current path is " << connectedPath << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Current path is " << connectedPath << "." << endl);
 
     // go through list, look for reappearance of starting Point and count
@@ -4129,12 +4129,12 @@
       if ((*CircleRunner == *CircleStart) && (CircleRunner != CircleStart)) { // is not the very first point
         // we have a closed circle from Marker to new Marker
-        Log() << Verbose(1) << count + 1 << ". closed path consists of: ";
+        DoLog(1) && (Log() << Verbose(1) << count + 1 << ". closed path consists of: ");
         newPath = new TesselPointList;
         TesselPointList::iterator CircleSprinter = Marker;
         for (; CircleSprinter != CircleRunner; CircleSprinter++) {
           newPath->push_back(*CircleSprinter);
-          Log() << Verbose(0) << (**CircleSprinter) << " <-> ";
+          DoLog(0) && (Log() << Verbose(0) << (**CircleSprinter) << " <-> ");
         }
-        Log() << Verbose(0) << ".." << endl;
+        DoLog(0) && (Log() << Verbose(0) << ".." << endl);
         count++;
         Marker = CircleRunner;
@@ -4145,5 +4145,5 @@
     }
   }
-  Log() << Verbose(1) << "INFO: " << count << " closed additional path(s) have been created." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: " << count << " closed additional path(s) have been created." << endl);
 
   // delete list of paths
@@ -4207,5 +4207,5 @@
     return 0.;
   } else
-    Log() << Verbose(0) << "Removing point " << *point << " from tesselated boundary ..." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Removing point " << *point << " from tesselated boundary ..." << endl);
 
   // copy old location for the volume
@@ -4237,10 +4237,10 @@
   NormalVector.Zero();
   for (TriangleMap::iterator Runner = Candidates.begin(); Runner != Candidates.end(); Runner++) {
-    Log() << Verbose(1) << "INFO: Removing triangle " << *(Runner->second) << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Removing triangle " << *(Runner->second) << "." << endl);
     NormalVector.SubtractVector(&Runner->second->NormalVector); // has to point inward
     RemoveTesselationTriangle(Runner->second);
     count++;
   }
-  Log() << Verbose(1) << count << " triangles were removed." << endl;
+  DoLog(1) && (Log() << Verbose(1) << count << " triangles were removed." << endl);
 
   list<TesselPointList *>::iterator ListAdvance = ListOfClosedPaths->begin();
@@ -4266,5 +4266,5 @@
         smallestangle = 0.;
         for (MiddleNode = connectedPath->begin(); MiddleNode != connectedPath->end(); MiddleNode++) {
-          Log() << Verbose(1) << "INFO: MiddleNode is " << **MiddleNode << "." << endl;
+          DoLog(1) && (Log() << Verbose(1) << "INFO: MiddleNode is " << **MiddleNode << "." << endl);
           // construct vectors to next and previous neighbour
           StartNode = MiddleNode;
@@ -4304,8 +4304,8 @@
         if (EndNode == connectedPath->end())
           EndNode = connectedPath->begin();
-        Log() << Verbose(2) << "INFO: StartNode is " << **StartNode << "." << endl;
-        Log() << Verbose(2) << "INFO: MiddleNode is " << **MiddleNode << "." << endl;
-        Log() << Verbose(2) << "INFO: EndNode is " << **EndNode << "." << endl;
-        Log() << Verbose(1) << "INFO: Attempting to create triangle " << (*StartNode)->Name << ", " << (*MiddleNode)->Name << " and " << (*EndNode)->Name << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "INFO: StartNode is " << **StartNode << "." << endl);
+        DoLog(2) && (Log() << Verbose(2) << "INFO: MiddleNode is " << **MiddleNode << "." << endl);
+        DoLog(2) && (Log() << Verbose(2) << "INFO: EndNode is " << **EndNode << "." << endl);
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Attempting to create triangle " << (*StartNode)->Name << ", " << (*MiddleNode)->Name << " and " << (*EndNode)->Name << "." << endl);
         TriangleCandidates[0] = *StartNode;
         TriangleCandidates[1] = *MiddleNode;
@@ -4325,9 +4325,9 @@
           continue;
         }
-        Log() << Verbose(3) << "Adding new triangle points." << endl;
+        DoLog(3) && (Log() << Verbose(3) << "Adding new triangle points." << endl);
         AddTesselationPoint(*StartNode, 0);
         AddTesselationPoint(*MiddleNode, 1);
         AddTesselationPoint(*EndNode, 2);
-        Log() << Verbose(3) << "Adding new triangle lines." << endl;
+        DoLog(3) && (Log() << Verbose(3) << "Adding new triangle lines." << endl);
         AddTesselationLine(NULL, NULL, TPS[0], TPS[1], 0);
         AddTesselationLine(NULL, NULL, TPS[0], TPS[2], 1);
@@ -4344,5 +4344,5 @@
         // prepare nodes for next triangle
         StartNode = EndNode;
-        Log() << Verbose(2) << "Removing " << **MiddleNode << " from closed path, remaining points: " << connectedPath->size() << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Removing " << **MiddleNode << " from closed path, remaining points: " << connectedPath->size() << "." << endl);
         connectedPath->remove(*MiddleNode); // remove the middle node (it is surrounded by triangles)
         if (connectedPath->size() == 2) { // we are done
@@ -4380,5 +4380,5 @@
           if (maxgain != 0) {
             volume += maxgain;
-            Log() << Verbose(1) << "Flipping baseline with highest volume" << **Candidate << "." << endl;
+            DoLog(1) && (Log() << Verbose(1) << "Flipping baseline with highest volume" << **Candidate << "." << endl);
             OtherBase = FlipBaseline(*Candidate);
             NewLines.erase(Candidate);
@@ -4391,5 +4391,5 @@
       delete (connectedPath);
     }
-    Log() << Verbose(0) << count << " triangles were created." << endl;
+    DoLog(0) && (Log() << Verbose(0) << count << " triangles were created." << endl);
   } else {
     while (!ListOfClosedPaths->empty()) {
@@ -4399,9 +4399,9 @@
       delete (connectedPath);
     }
-    Log() << Verbose(0) << "No need to create any triangles." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "No need to create any triangles." << endl);
   }
   delete (ListOfClosedPaths);
 
-  Log() << Verbose(0) << "Removed volume is " << volume << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Removed volume is " << volume << "." << endl);
 
   return volume;
@@ -4568,5 +4568,5 @@
   AllLines.clear();
 
-  Log() << Verbose(0) << "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines." << endl);
   IndexToIndex::iterator it;
   for (it = DegeneratedLines->begin(); it != DegeneratedLines->end(); it++) {
@@ -4574,5 +4574,5 @@
     const LineMap::const_iterator Line2 = LinesOnBoundary.find((*it).second);
     if (Line1 != LinesOnBoundary.end() && Line2 != LinesOnBoundary.end())
-      Log() << Verbose(0) << *Line1->second << " => " << *Line2->second << endl;
+      DoLog(0) && (Log() << Verbose(0) << *Line1->second << " => " << *Line2->second << endl);
     else
       DoeLog(1) && (eLog() << Verbose(1) << "Either " << (*it).first << " or " << (*it).second << " are not in LinesOnBoundary!" << endl);
@@ -4616,8 +4616,8 @@
   delete (DegeneratedLines);
 
-  Log() << Verbose(0) << "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:" << endl);
   IndexToIndex::iterator it;
   for (it = DegeneratedTriangles->begin(); it != DegeneratedTriangles->end(); it++)
-    Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl);
 
   return DegeneratedTriangles;
@@ -4687,11 +4687,11 @@
       // erase the pair
       count += (int) DegeneratedTriangles->erase(triangle->Nr);
-      Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *triangle << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *triangle << "." << endl);
       RemoveTesselationTriangle(triangle);
       count += (int) DegeneratedTriangles->erase(partnerTriangle->Nr);
-      Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << "." << endl);
       RemoveTesselationTriangle(partnerTriangle);
     } else {
-      Log() << Verbose(0) << "RemoveDegeneratedTriangles() does not remove triangle " << *triangle << " and its partner " << *partnerTriangle << " because it is essential for at" << " least one of the endpoints to be kept in the tesselation structure." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() does not remove triangle " << *triangle << " and its partner " << *partnerTriangle << " because it is essential for at" << " least one of the endpoints to be kept in the tesselation structure." << endl);
     }
   }
@@ -4700,5 +4700,5 @@
     LastTriangle = NULL;
 
-  Log() << Verbose(0) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl);
 }
 
@@ -4729,5 +4729,5 @@
     return;
   }
-  Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl);
 
   // go through its lines and find the best one to split
@@ -4762,9 +4762,9 @@
 
   // create new triangle to connect point (connects automatically with the missing spot of the chosen line)
-  Log() << Verbose(2) << "Adding new triangle points." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle points." << endl);
   AddTesselationPoint((BestLine->endpoints[0]->node), 0);
   AddTesselationPoint((BestLine->endpoints[1]->node), 1);
   AddTesselationPoint(point, 2);
-  Log() << Verbose(2) << "Adding new triangle lines." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle lines." << endl);
   AddTesselationLine(NULL, NULL, TPS[0], TPS[1], 0);
   AddTesselationLine(NULL, NULL, TPS[0], TPS[2], 1);
@@ -4773,13 +4773,13 @@
   BTS->GetNormalVector(TempTriangle->NormalVector);
   BTS->NormalVector.Scale(-1.);
-  Log() << Verbose(1) << "INFO: NormalVector of new triangle is " << BTS->NormalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: NormalVector of new triangle is " << BTS->NormalVector << "." << endl);
   AddTesselationTriangle();
 
   // create other side of this triangle and close both new sides of the first created triangle
-  Log() << Verbose(2) << "Adding new triangle points." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle points." << endl);
   AddTesselationPoint((BestLine->endpoints[0]->node), 0);
   AddTesselationPoint((BestLine->endpoints[1]->node), 1);
   AddTesselationPoint(point, 2);
-  Log() << Verbose(2) << "Adding new triangle lines." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Adding new triangle lines." << endl);
   AddTesselationLine(NULL, NULL, TPS[0], TPS[1], 0);
   AddTesselationLine(NULL, NULL, TPS[0], TPS[2], 1);
@@ -4787,5 +4787,5 @@
   BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
   BTS->GetNormalVector(TempTriangle->NormalVector);
-  Log() << Verbose(1) << "INFO: NormalVector of other new triangle is " << BTS->NormalVector << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: NormalVector of other new triangle is " << BTS->NormalVector << "." << endl);
   AddTesselationTriangle();
 
@@ -4825,5 +4825,5 @@
         NameofTempFile.erase(npos, 1);
       NameofTempFile.append(TecplotSuffix);
-      Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+      DoLog(0) && (Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n");
       tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
       WriteTecplotFile(tempstream, this, cloud, TriangleFilesWritten);
@@ -4839,5 +4839,5 @@
         NameofTempFile.erase(npos, 1);
       NameofTempFile.append(Raster3DSuffix);
-      Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+      DoLog(0) && (Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n");
       tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
       WriteRaster3dFile(tempstream, this, cloud);
@@ -4891,8 +4891,8 @@
   pair<map<int, Vector *>::iterator, bool> TriangleInsertionTester;
   for (PointMap::const_iterator Runner = PointsOnBoundary.begin(); Runner != PointsOnBoundary.end(); Runner++) {
-    Log() << Verbose(0) << "Current point is " << *Runner->second << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Current point is " << *Runner->second << "." << endl);
     map<int, Vector *> TriangleVectors;
     // gather all NormalVectors
-    Log() << Verbose(1) << "Gathering triangles ..." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Gathering triangles ..." << endl);
     for (LineMap::const_iterator LineRunner = (Runner->second)->lines.begin(); LineRunner != (Runner->second)->lines.end(); LineRunner++)
       for (TriangleMap::const_iterator TriangleRunner = (LineRunner->second)->triangles.begin(); TriangleRunner != (LineRunner->second)->triangles.end(); TriangleRunner++) {
@@ -4900,20 +4900,20 @@
           TriangleInsertionTester = TriangleVectors.insert(pair<int, Vector *> ((TriangleRunner->second)->Nr, &((TriangleRunner->second)->NormalVector)));
           if (TriangleInsertionTester.second)
-            Log() << Verbose(1) << " Adding triangle " << *(TriangleRunner->second) << " to triangles to check-list." << endl;
+            DoLog(1) && (Log() << Verbose(1) << " Adding triangle " << *(TriangleRunner->second) << " to triangles to check-list." << endl);
         } else {
-          Log() << Verbose(1) << " NOT adding triangle " << *(TriangleRunner->second) << " as it's a simply degenerated one." << endl;
+          DoLog(1) && (Log() << Verbose(1) << " NOT adding triangle " << *(TriangleRunner->second) << " as it's a simply degenerated one." << endl);
         }
       }
     // check whether there are two that are parallel
-    Log() << Verbose(1) << "Finding two parallel triangles ..." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Finding two parallel triangles ..." << endl);
     for (map<int, Vector *>::iterator VectorWalker = TriangleVectors.begin(); VectorWalker != TriangleVectors.end(); VectorWalker++)
       for (map<int, Vector *>::iterator VectorRunner = VectorWalker; VectorRunner != TriangleVectors.end(); VectorRunner++)
         if (VectorWalker != VectorRunner) { // skip equals
           const double SCP = VectorWalker->second->ScalarProduct(VectorRunner->second); // ScalarProduct should result in -1. for degenerated triangles
-          Log() << Verbose(1) << "Checking " << *VectorWalker->second << " against " << *VectorRunner->second << ": " << SCP << endl;
+          DoLog(1) && (Log() << Verbose(1) << "Checking " << *VectorWalker->second << " against " << *VectorRunner->second << ": " << SCP << endl);
           if (fabs(SCP + 1.) < ParallelEpsilon) {
             InsertionTester = EndpointCandidateList.insert((Runner->second));
             if (InsertionTester.second)
-              Log() << Verbose(0) << " Adding " << *Runner->second << " to endpoint candidate list." << endl;
+              DoLog(0) && (Log() << Verbose(0) << " Adding " << *Runner->second << " to endpoint candidate list." << endl);
             // and break out of both loops
             VectorWalker = TriangleVectors.end();
@@ -4933,5 +4933,5 @@
     Walker = *(EndpointCandidateList.begin());
     if (Current == NULL) { // create a new polygon with current candidate
-      Log() << Verbose(0) << "Starting new polygon set at point " << *Walker << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Starting new polygon set at point " << *Walker << endl);
       Current = new BoundaryPolygonSet;
       Current->endpoints.insert(Walker);
@@ -4946,18 +4946,18 @@
       for (LineMap::const_iterator LineWalker = Walker->lines.begin(); LineWalker != Walker->lines.end(); LineWalker++) {
         OtherWalker = (LineWalker->second)->GetOtherEndpoint(Walker);
-        Log() << Verbose(1) << "Checking " << *OtherWalker << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Checking " << *OtherWalker << endl);
         set<BoundaryPointSet *>::iterator Finder = EndpointCandidateList.find(OtherWalker);
         if (Finder != EndpointCandidateList.end()) { // found a connected partner
-          Log() << Verbose(1) << " Adding to polygon." << endl;
+          DoLog(1) && (Log() << Verbose(1) << " Adding to polygon." << endl);
           Current->endpoints.insert(OtherWalker);
           EndpointCandidateList.erase(Finder); // remove from candidates
           ToCheckConnecteds.push(OtherWalker); // but check its partners too
         } else {
-          Log() << Verbose(1) << " is not connected to " << *Walker << endl;
+          DoLog(1) && (Log() << Verbose(1) << " is not connected to " << *Walker << endl);
         }
       }
     }
 
-    Log() << Verbose(0) << "Final polygon is " << *Current << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Final polygon is " << *Current << endl);
     ListofDegeneratedPolygons.insert(Current);
     Current = NULL;
@@ -4966,7 +4966,7 @@
   const int counter = ListofDegeneratedPolygons.size();
 
-  Log() << Verbose(0) << "The following " << counter << " degenerated polygons have been found: " << endl;
+  DoLog(0) && (Log() << Verbose(0) << "The following " << counter << " degenerated polygons have been found: " << endl);
   for (UniquePolygonSet::iterator PolygonRunner = ListofDegeneratedPolygons.begin(); PolygonRunner != ListofDegeneratedPolygons.end(); PolygonRunner++)
-    Log() << Verbose(0) << " " << **PolygonRunner << endl;
+    DoLog(0) && (Log() << Verbose(0) << " " << **PolygonRunner << endl);
 
   /// 4. Go through all these degenerated polygons
@@ -4979,5 +4979,5 @@
     // check whether number is bigger than 2, otherwise it's just a simply degenerated one and nothing to do.
     if (T->size() == 2) {
-      Log() << Verbose(1) << " Skipping degenerated polygon, is just a (already simply degenerated) triangle." << endl;
+      DoLog(1) && (Log() << Verbose(1) << " Skipping degenerated polygon, is just a (already simply degenerated) triangle." << endl);
       delete (T);
       continue;
@@ -4995,5 +4995,5 @@
     /// 4a. Get NormalVector for one side (this is "front")
     NormalVector.CopyVector(&(*TriangleWalker)->NormalVector);
-    Log() << Verbose(1) << "\"front\" defining triangle is " << **TriangleWalker << " and Normal vector of \"front\" side is " << NormalVector << endl;
+    DoLog(1) && (Log() << Verbose(1) << "\"front\" defining triangle is " << **TriangleWalker << " and Normal vector of \"front\" side is " << NormalVector << endl);
     TriangleWalker++;
     TriangleSet::iterator TriangleSprinter = TriangleWalker; // is the inner advanced iterator
@@ -5004,17 +5004,17 @@
       triangle = *TriangleWalker;
       TriangleSprinter++;
-      Log() << Verbose(1) << "Current triangle to test for removal: " << *triangle << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Current triangle to test for removal: " << *triangle << endl);
       if (triangle->NormalVector.ScalarProduct(&NormalVector) < 0) { // if from other side, then delete and remove from list
-        Log() << Verbose(1) << " Removing ... " << endl;
+        DoLog(1) && (Log() << Verbose(1) << " Removing ... " << endl);
         TriangleNrs.push(triangle->Nr);
         T->erase(TriangleWalker);
         RemoveTesselationTriangle(triangle);
       } else
-        Log() << Verbose(1) << " Keeping ... " << endl;
+        DoLog(1) && (Log() << Verbose(1) << " Keeping ... " << endl);
     }
     /// 4c. Copy all "front" triangles but with inverse NormalVector
     TriangleWalker = T->begin();
     while (TriangleWalker != T->end()) { // go through all front triangles
-      Log() << Verbose(1) << " Re-creating triangle " << **TriangleWalker << " with NormalVector " << (*TriangleWalker)->NormalVector << endl;
+      DoLog(1) && (Log() << Verbose(1) << " Re-creating triangle " << **TriangleWalker << " with NormalVector " << (*TriangleWalker)->NormalVector << endl);
       for (int i = 0; i < 3; i++)
         AddTesselationPoint((*TriangleWalker)->endpoints[i]->node, i);
@@ -5037,8 +5037,8 @@
   }
   IndexToIndex * SimplyDegeneratedTriangles = FindAllDegeneratedTriangles();
-  Log() << Verbose(0) << "Final list of simply degenerated triangles found, containing " << SimplyDegeneratedTriangles->size() << " triangles:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Final list of simply degenerated triangles found, containing " << SimplyDegeneratedTriangles->size() << " triangles:" << endl);
   IndexToIndex::iterator it;
   for (it = SimplyDegeneratedTriangles->begin(); it != SimplyDegeneratedTriangles->end(); it++)
-    Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl;
+    DoLog(0) && (Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl);
   delete (SimplyDegeneratedTriangles);
   /// 5. exit
